#!/usr/bin/perl
#
# MythWeb Streaming/Download module
#
# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-23-fixes/mythplugins/mythweb/modules/stream/tv.pl $
# @date      $Date: 2009-03-05 07:47:23 +0000 (Thu, 05 Mar 2009) $
# @version   $Revision: 20110 $
# @author    $Author: kormoc $
#

    use Sys::Hostname;
    use File::Basename;

# Attempt to use the perl bindings to prevent the backend from shutting down during streaming
    eval 'use MythTV;';

    if (!$@) {
        our $mythbackend = new MythTV();
        $mythbackend->backend_command('ANN Playback '.hostname);
    }

# Which show are we streaming?
    our $chanid    = url_param('chanid');
    our $starttime = url_param('starttime');
    if ($Path[1]) {
        $chanid    = $Path[1];
        $starttime = $Path[2];
        $starttime =~ s/\.\w+$//;
    }

# Get the basename from the database
    my $sh = $dbh->prepare('SELECT basename, title, subtitle, endtime-starttime
                              FROM recorded
                             WHERE starttime=FROM_UNIXTIME(?)
                                   AND recorded.chanid   = ?');
    $sh->execute($starttime, $chanid);
    our ($basename, $title, $subtitle, $runtime) = $sh->fetchrow_array();
    $sh->finish;

# No match?
    unless ($basename =~ /\w/) {
        print header(),
              "Unknown recording requested.\n";
        exit;
    }

# Find the local file
    our $filename;
    our $filename_nocomm;
    $sh = $dbh->prepare('SELECT DISTINCT dirname
                           FROM storagegroup');
    $sh->execute();
    while (my ($video_dir) = $sh->fetchrow_array()) {
        next unless (-e "$video_dir/$basename");
        $filename = "$video_dir/$basename";
        ($fileBaseName, $dirName, $fileExtension) = fileparse($filename, ('\.mpg') );
        $basename_nocomm = "$fileBaseName" . "_nocomm";
        $filename_nocomm = "$dirName" . "$basename_nocomm" . "$fileExtension";
		# $basename =~ m/(.*)\.mpg/;
        # $basename_noext = $1;
        # $basename_nocomm = "$basename_noext" . "_nocomm.mpg";
        # $filename_nocomm = "$video_dir/$basename_nocomm";
        last;
    }
    $sh->finish;

    1;
